# Copyright © 2020 Profirator Oy, HYPERTEGRITY AG, omp computer gmbh
# This file is covered by the EUPL license.
# You may obtain a copy of the licence at
# https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12

#VARIABLES

#Resource requests. Memory 1 Mi = 1 Mebibyte. CPU 1000m = 1 CPU
#Tenant Manager
variables:
  #DEV
  DEV_MEMORY: "50Mi"
  DEV_CPU: "50m"
  #STAGING
  STAGING_MEMORY: "1000Mi"
  STAGING_CPU: "250m"
  #PROD
  PROD_MEMORY: "1000Mi"
  PROD_CPU: "250m"

#TEMPLATES

.deploy_template: &deploy_template
  tags:
    - kubernetes
  image: bitnami/kubectl:latest
  stage: deploy
  script:
    - echo "$KUBE" > "$(pwd)/kube.config"
    - sed -i "s/DOMAIN/${DOMAIN}/g" tenantmanager-deployment.yaml
    - sed -i "s/BRANCHNAME/${BRANCHNAME}/g" tenantmanager-deployment.yaml
    - sed -i "s/MEMORYREQUEST/${MEMORYREQUEST}/g" tenantmanager-deployment.yaml
    - sed -i "s/CPUREQUEST/${CPUREQUEST}/g" tenantmanager-deployment.yaml
    - kubectl apply -f tenantmanager-deployment.yaml -n ${NAMESPACE} --kubeconfig "$(pwd)/kube.config"

stages:
  - build
  - deploy

do build:
  tags:
    - shared
  image: docker:stable
  stage: build
  before_script:
    - docker info
    - env
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY

  script:
    # Handle secrets and configs here --
    - docker build -t tenantmanager .
    - docker tag tenantmanager "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG"
    - docker push "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG"


do deploy dev:
  <<: *deploy_template
  variables:
    NAMESPACE: $NAMESPACE_DEV
    BRANCHNAME: "master"
    DOMAIN: $TENANT_DEV_DOMAIN
    KUBE: $KUBECONFIG
    MEMORYREQUEST: $DEV_MEMORY
    CPUREQUEST: $DEV_CPU
  only:
    - master

do deploy staging:
  <<: *deploy_template
  variables:
    NAMESPACE: $NAMESPACE_STAGING
    BRANCHNAME: $CI_COMMIT_REF_SLUG
    DOMAIN: $TENANT_STAGING_DOMAIN
    KUBE: $KUBECONFIG
    MEMORYREQUEST: $STAGING_MEMORY
    CPUREQUEST: $STAGING_CPU
  only:
    - /^C./


do deploy prod:
  <<: *deploy_template
  variables:
    NAMESPACE: $NAMESPACE_PROD
    BRANCHNAME: $CI_COMMIT_REF_SLUG
    DOMAIN: $TENANT_PROD_DOMAIN
    KUBE: $KUBECONFIG_PROD
    MEMORYREQUEST: $PROD_MEMORY
    CPUREQUEST: $PROD_CPU
  only:
    - /^R./
  when: manual

